var GtagCustomMP = {
    id: 'UA-182400616-1',
    link: 'https://www.googletagmanager.com/gtag/js?id=',
    additionalMap: { dimension1: 'cid', dimension2: 'ad_id', dimension3: 'adset_id', dimension4: 'cpid', dimension5: 'product_id', dimension6: 'pixel' },
    params: {},
    getParam: function (param) { return this.params[param] || 'N/A' },
    parseParams: function () {
        let url = window.location.search
        let urlParamsSplited = url.replace('?', '').split('&')
        let urlParamsParsed = {};
        for (let i = 0; i < urlParamsSplited.length; i++) {
            let temp = urlParamsSplited[i].split('=')
            urlParamsParsed[temp[0]] = temp[1]
        }
        this.params = urlParamsParsed
    },
    init: function () {
        this.downloadScript(this.link + this.id, 'text/javascript', true);
        this.parseParams()
        window.dataLayer = window.dataLayer || [];
        this.request('js', new Date());
        this.createTrackerConfig()
        this.sendCheckout('Begin checkout', 1, 'begin_checkout')
    },
    request() { dataLayer.push(arguments) },
    createTrackerConfig() {
        // GtagCustomMP.request('set', { 'user_id': GtagCustomMP.getParam('cid') })
        this.request('config', this.id, {
            cookie_prefix: 'gcmp',
            send_page_view: true,
            custom_map: this.additionalMap
        })
    },
    sendCheckout: function (label, step, eventName) {
        const settings = {
            send_to: this.id,
            'cid': this.getParam('cid'),
            'ad_id': this.getParam('ad_id'),
            'adset_id': this.getParam('adset_id'),
            'cpid': this.getParam('cpid'),
            'product_id': this.getParam('product_id'),
            'pixel': this.getParam('pixel'),
            'checkout_step': step,
            items: [
                {
                    id: settingsObject[defaultCountry]['productId'],
                    name: settingsObject[defaultCountry]['productName'],
                    quantity: 1,
                    price: 1,
                }
            ],
            event_label: label,
            currency: 'USD',
        }
        // settingsObject
        this.request('event', eventName, settings)
    },
    sendCheckout2: function () {

        const settings = {
            send_to: this.id,
            'cid': this.getParam('cid'),
            'ad_id': this.getParam('ad_id'),
            'adset_id': this.getParam('adset_id'),
            'cpid': this.getParam('cpid'),
            'product_id': this.getParam('product_id'),
            "affiliation": "TEST",
            'pixel': this.getParam('pixel'),
            items: [
                {
                    id: settingsAdditional['offer_id'],
                    name: settingsAdditional['name'],
                    quantity: 1,
                    price: 1,
                }

            ],
            'transaction_id': this.getParam('cid'),
            event_label: 'Confirm',
            currency: 'USD',
            value: 50,
        }
        // settingsObject
        this.request('event', 'purchase', settings)
    },
    downloadScript(url, type, async) { const a = document.createElement('script'); a.type = type; a.async = async; a.src = url; const b = document.getElementsByTagName('script')[0]; b.parentNode.insertBefore(a, b) },
};
$(document).ready(function () {
    GtagCustomMP.init()
})
