$(document).ready(function () {

    let url = document.location.search
    let urlParsed = url.replace('?', '').split('&')
    let urlObject = {}
    for (let i = 0; i < urlParsed.length; i++) {
        let temp = urlParsed[i].split('=')
        urlObject[temp[0]] = temp[1]
    }

    if (!urlObject['pixel']) return

    var topWindow = window.top
    if (topWindow === window) return

    function sendInfoEvent(name) {
        topWindow.postMessage('INFO-' + name, serverReferal);
    }

    function sendFBEvent(name, value) {
        if (value) topWindow.postMessage('FB-' + name + '-' + value, serverReferal);
        else topWindow.postMessage('FB-' + name, serverReferal);
    }

    function sendCustomFBEvent(name, value) {
        if (value) topWindow.postMessage('FBC-' + name + '-' + value, serverReferal);
        else topWindow.postMessage('FBC-' + name, serverReferal);
    }

    sendInfoEvent('ChildExists')
    sendFBEvent('ViewContent', 0.15)

    // Time on page events
    setTimeout(function () { sendCustomFBEvent('TimeOnPage30', 0.5) }, 30000)
    setTimeout(function () { sendCustomFBEvent('TimeOnPage60', 0.8) }, 60000)

    // Input change events
    let trackCompletedSubmit = 0
    let names = document.getElementsByName('name')
    let phones = document.getElementsByName('phone')

    function nameChange(e) {
        console.log("name changed")
        sendFBEvent('Contact', 1)
        removeInputEvents('name')
        completedForm()
    }

    function phoneChange(e) {
        console.log("phone changed")
        sendFBEvent('Contact', 1.5)
        removeInputEvents('phone')
        completedForm()
    }

    function completedForm() {
        trackCompletedSubmit++
        if (trackCompletedSubmit === 2) sendFBEvent('SubmitApplication', 3)
    }

    for (let i = 0; i < names.length; i++) {
        names[i].addEventListener('change', nameChange)
    }
    for (let i = 0; i < phones.length; i++) {
        phones[i].addEventListener('change', phoneChange)
    }

    function removeInputEvents(name) {
        let inputArray = name === 'name' ? names : phones
        for (let i = 0; i < inputArray.length; i++) {
            inputArray[i].removeEventListener('change', nameChange)
            inputArray[i].removeEventListener('change', phoneChange)
        }
    }

    // Scroll events
    let scrollData = {}

    function getScrollPercent() {
        let h = document.documentElement,
            b = document.body,
            st = 'scrollTop',
            sh = 'scrollHeight';
        return (h[st] || b[st]) / ((h[sh] || b[sh]) - h.clientHeight) * 100;
    }

    function scrollTracking(e) {
        let currentScroll = getScrollPercent()
        if (currentScroll >= 50 && !scrollData['50']) {
            scrollData['50'] = true;
            sendCustomFBEvent('ViewContent50', 0.2)
        }
        if (currentScroll >= 80 && !scrollData['80']) {
            scrollData['80'] = true;
            sendCustomFBEvent('ViewContent80', 0.3)
        }
        if (currentScroll >= 100 && !scrollData['100']) {
            scrollData['100'] = true;
            sendCustomFBEvent('ViewContent100', 0.5)
        }
        if (scrollData['50'] && scrollData['80'] && scrollData['100']) {
            window.removeEventListener('scroll', scrollTracking)
        }
    }
    window.addEventListener('scroll', scrollTracking)

})